#include "sysdefs.h"
#include "kolibri.h"
#include "string.h"

extern char KOL_PATH[256];
extern char KOL_PARAM[256];
extern char KOL_DIR[256];

 __declspec(noreturn) void __cdecl kol_exit()
{
    INTEL_ASM
    __asm __volatile__("mov eax, -1\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_sleep(unsigned d)
{
    INTEL_ASM
     __asm __volatile__("mov ebx, %0\n"::"m"(d));
     __asm __volatile__("mov eax, 5\n");
     __asm __volatile__("int 0x40\n");
}

void __cdecl kol_wnd_define(unsigned x, unsigned y, unsigned w, unsigned h, unsigned c)
{
    int _eb = x * 65536 + w;
    int _ec = y * 65536 + h;
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(_eb));
    __asm __volatile__("mov ecx, %0\n"::"m"(_ec));
    __asm __volatile__("mov edx, %0\n"::"m"(c));
    __asm __volatile__("xor eax, eax\n");
    __asm __volatile__("mov esi, 0xFFFFFF\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_wnd_move(unsigned x, unsigned y)
{
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(x));
    __asm __volatile__("mov ecx, %0\n"::"m"(y));
    __asm __volatile__("mov eax, 67\n");
    __asm __volatile__("mov edx, -1\n");
    __asm __volatile__("mov esi, -1\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_event_mask(unsigned e)
{
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(e));
    __asm __volatile__("mov eax, 40\n");
    __asm __volatile__("int 0x40\n");
}


unsigned __cdecl kol_event_wait()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 10\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_event_wait_time(unsigned time)
{
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(time));
    __asm __volatile__("mov eax, 23\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_event_check()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 11\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_start()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 12\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_end()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 12\n");
    __asm __volatile__("mov ebx, 2\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_pixel(unsigned x, unsigned y, unsigned c)
{
    INTEL_ASM
    __asm __volatile__("mov edx, %0\n"::"m"(c));
    __asm __volatile__("mov ecx, %0\n"::"m"(y));
    __asm __volatile__("mov ebx, %0\n"::"m"(x));
    __asm __volatile__("mov eax, 1\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_bar(unsigned x, unsigned y, unsigned w, unsigned h, unsigned c)
{
    int _eb = x * 65536 + w;
    int _ec = y * 65536 + h;
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(_eb));
    __asm __volatile__("mov ecx, %0\n"::"m"(_ec));
    __asm __volatile__("mov edx, %0\n"::"m"(c));
    __asm __volatile__("mov eax, 13\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_line(unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned c)
{
    unsigned _eb = x1 * 65536 + x2;
    unsigned _ec = y1 * 65536 + y2;
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(_eb));
    __asm __volatile__("mov ecx, %0\n"::"m"(_ec));
    __asm __volatile__("mov edx, %0\n"::"m"(c));
    __asm __volatile__("mov eax, 38\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_string(unsigned x, unsigned y, char *s, unsigned c)
{
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(x));
    __asm __volatile__("shl ebx, 16\n");
    __asm __volatile__("add ebx, %0\n"::"m"(y));
    __asm __volatile__("mov ecx, %0\n"::"m"(c));
    __asm __volatile__("mov edx, %0\n"::"m"(s));
    __asm __volatile__("mov eax, 4\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_image(unsigned x, unsigned y, unsigned w, unsigned h, char *d)
{
    unsigned _ec = w * 65536 + h;
    unsigned _ed = x * 65536 + y;
    INTEL_ASM
    __asm __volatile__("mov ecx, %0\n"::"m"(_ec));
    __asm __volatile__("mov edx, %0\n"::"m"(_ed));
    __asm __volatile__("mov ebx, %0\n"::"m"(d));
    __asm __volatile__("mov eax, 7\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_paint_image_pal(unsigned x, unsigned y, unsigned w, unsigned h, char *d, unsigned *palette)
{
    unsigned _ec = w * 65536 + h;
    unsigned _ed = x * 65536 + y;
    INTEL_ASM
    __asm __volatile__("mov ecx, %0\n"::"m"(_ec));
    __asm __volatile__("mov edx, %0\n"::"m"(_ed));
    __asm __volatile__("mov ebx, %0\n"::"m"(d));
    __asm __volatile__("mov edi, %0\n"::"m"(palette));
    __asm __volatile__("xor ebp, ebp\n");
    __asm __volatile__("push 8\n");
    __asm __volatile__("pop esi\n");
    __asm __volatile__("mov eax, 65\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_key_get()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 2\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_key_control()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 66\n");
    __asm __volatile__("mov ebx, 3\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_key_lang_set(unsigned lang)
{
    INTEL_ASM
    __asm __volatile__("mov edx, %0\n"::"m"(lang));
    __asm __volatile__("mov eax, 21\n");
    __asm __volatile__("mov ebx, 2\n");
    __asm __volatile__("mov ecx, 9\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_key_lang_get()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 26\n");
    __asm __volatile__("mov ebx, 2\n");
    __asm __volatile__("mov ecx, 9\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_key_mode_set(unsigned mode)
{
    INTEL_ASM
    __asm __volatile__("mov ecx, %0\n"::"m"(mode));
    __asm __volatile__("mov eax, 66\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_key_mode_get()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 66\n");
    __asm __volatile__("mov ebx, 2\n");
    __asm __volatile__("int 0x40");
}

unsigned __cdecl kol_btn_get()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 17\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_btn_define(unsigned x, unsigned y, unsigned w, unsigned h, unsigned d, unsigned c)
{
    unsigned _eb = x * 65536 + w;
    unsigned _ec = y * 65536 + h;
    INTEL_ASM
    __asm __volatile__("mov edx, %0\n"::"m"(d));
    __asm __volatile__("mov ebx, %0\n"::"m"(_eb));
    __asm __volatile__("mov ecx, %0\n"::"m"(_ec));
    __asm __volatile__("mov esi, %0\n"::"m"(c));
    __asm __volatile__("mov eax, 8\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_btn_type(unsigned t)
{
    INTEL_ASM
    __asm __volatile__("mov ecx, %0\n"::"m"(t));
    __asm __volatile__("mov eax, 48\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_wnd_caption(char *s)
{
    INTEL_ASM
    __asm __volatile__("mov ecx, %0\n"::"m"(s));
    __asm __volatile__("mov eax, 71\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_mouse_pos()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 37\n");
    __asm __volatile__("xor ebx, ebx\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_mouse_posw()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 37\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_mouse_btn()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 37\n");
    __asm __volatile__("mov ebx, 2\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_board_putc(char c)
{
    INTEL_ASM
    __asm __volatile__("mov cl, %0\n"::"m"(c));
    __asm __volatile__("mov eax, 63\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_board_puts(char *s)
{
    unsigned int i = 0;
    while (*(s + i)) {
        kol_board_putc(s[i]);
        i++;
    }
}

void __cdecl kol_board_puti(int n)
{
    char c = 0;
    unsigned int i = 0;
    do {
        c = n % 10 + '0';
        kol_board_putc(c);
	i++;
        }
        while ((n /= 10) > 0);
}

int __cdecl kol_file_70(kol_struct70 *k)
{
    INTEL_ASM
    __asm __volatile__("mov ebx, %0\n"::"m"(k));
    __asm __volatile__("mov eax, 70\n");
    __asm __volatile__("int 0x40\n");
}

kol_struct_import* __fastcall kol_cofflib_load(char *name)
{
    INTEL_ASM
    __asm __volatile__("mov eax, 68\n");
    __asm __volatile__("mov ebx, 19\n");
    __asm __volatile__("int 0x40\n");
}

void* __cdecl kol_cofflib_procload (kol_struct_import *imp, char *name)
{
    unsigned int i = 0;
    for (i = 0; ; i++)
	if ( NULL == ((imp + i) -> name))
		break;
	else
		if ( 0 == strcmp(name, (imp + i)->name) )
			return (imp + i)->data;
    return NULL;
}

unsigned __cdecl kol_cofflib_procnum (kol_struct_import *imp)
{
    unsigned int i = 0, n = 0;
    for (i = n = 0; ; i++)
	if ( NULL == ((imp + i) -> name))
		break;
	else
		n++;
    return n;
}

void __cdecl kol_cofflib_procname (kol_struct_import *imp, char *name, unsigned n)
{
    unsigned int i = 0;
//  char *name = 0; - Cant understand this :(
    for (i = 0; ; i++)
	if ( NULL == ((imp + i) -> name))
		break;
	else
		if ( i == n ){
                    strcpy(name, ((imp + i)->name));
                    break;
        }
}

unsigned __cdecl kol_system_cpufreq()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 18\n");
    __asm __volatile__("mov ebx, 5\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __fastcall kol_system_mem()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 18\n");
    __asm __volatile__("mov ebx, 17\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __fastcall kol_system_memfree()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 18\n");
    __asm __volatile__("mov ebx, 16\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __fastcall kol_system_time_get()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 3\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __fastcall kol_system_date_get()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 29\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __fastcall kol_system_end(unsigned param)
{
    INTEL_ASM
    __asm __volatile__("mov eax, 18\n");
    __asm __volatile__("mov ebx, 9\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_path_file2dir(char *dir, char *fname)
{
    unsigned int i = 0;
    strcpy (dir, fname);
    for ( i = strlen(dir);; --i) if ( '/' == dir[i]) {
        dir[i] = '\0';
        return;
        }
}

void __cdecl kol_path_full(char *full, char *fname)
{
    char temp[256];
    switch (*fname) {
        case '/':
                strncpy(temp, fname + 1, 2);
                temp[2] = 0;
                if ( (!strcmp("rd", temp)) || (!strcmp("hd", temp)) || (!strcmp("cd", temp)) )
		strcpy (full, fname);
            	break;
        case '.':
                break;
        default:
                break;
                };
}

void __cdecl kol_screen_wait_rr()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 18\n");
    __asm __volatile__("mov ebx, 14\n");
    __asm __volatile__("int 0x40\n");
}

void __cdecl kol_screen_get_size(unsigned *w, unsigned *h)
{
    unsigned _size;
    INTEL_ASM
    __asm __volatile__("mov eax, 14\n");
    __asm __volatile__("int 0x40\n");
    __asm __volatile__("mov %0, eax\n":"=m"(_size));
    *w = _size / 65536;
    *h = _size % 65536;
}

unsigned __cdecl kol_skin_height()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 48\n");
    __asm __volatile__("mov ebx, 4\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_thread_start(unsigned start, unsigned stack)
{
    INTEL_ASM
    __asm __volatile__("mov ecx, %0\n"::"m"(start));
    __asm __volatile__("mov edx, %0\n"::"m"(stack));
    __asm __volatile__("mov eax, 51\n");
    __asm __volatile__("mov ebx, 1\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_time_tick()
{
    INTEL_ASM
    __asm __volatile__("mov eax, 26\n");
    __asm __volatile__("mov ebx, 9\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __cdecl kol_sound_speaker(char data[])
{
    INTEL_ASM
    __asm __volatile__("mov esi, %0\n"::"m"(data));
    __asm __volatile__("mov eax, 55\n");
    __asm __volatile__("mov ebx, 55\n");
    __asm __volatile__("int 0x40\n");
}

unsigned __fastcall kol_process_info(unsigned slot, char buf1k[])
{
    INTEL_ASM
    __asm __volatile__("mov ebx, edx\n");
    __asm __volatile__("mov eax, 9\n");
    __asm __volatile__("int 0x40\n");
}

int __fastcall kol_process_kill_pid(unsigned process)
{
    INTEL_ASM
    __asm __volatile__("mov eax, 18\n");
    __asm __volatile__("mov ebx, 18\n");
    __asm __volatile__("int 0x40\n");
}
